/******************************************************************************/
/*                                                                            */
/*    ODYSSEUS/EduCOSMOS Educational-Purpose Object Storage System            */
/*                                                                            */
/*    Developed by Professor Kyu-Young Whang et al.                           */
/*                                                                            */
/*    Database and Multimedia Laboratory                                      */
/*                                                                            */
/*    Computer Science Department and                                         */
/*    Advanced Information Technology Research Center (AITrc)                 */
/*    Korea Advanced Institute of Science and Technology (KAIST)              */
/*                                                                            */
/*    e-mail: kywhang@cs.kaist.ac.kr                                          */
/*    phone: +82-42-350-7722                                                  */
/*    fax: +82-42-350-8380                                                    */
/*                                                                            */
/*    Copyright (c) 1995-2013 by Kyu-Young Whang                              */
/*                                                                            */
/*    All rights reserved. No part of this software may be reproduced,        */
/*    stored in a retrieval system, or transmitted, in any form or by any     */
/*    means, electronic, mechanical, photocopying, recording, or otherwise,   */
/*    without prior written permission of the copyright owner.                */
/*                                                                            */
/******************************************************************************/
#ifndef _EDUOM_TESTMODULE_H_
#define _EDUOM_TESTMODULE_H_


#include "BfM.h"
#include "Util_pool.h"



/*
 * Definition for EduOM Test Module
 */
#define MAX_DEVICES_IN_VOLUME 20
#define FIRST_PAGE_OBJECT 84
#define THIRD_PAGE_OBJECT 170
#define ARRAYINDEX 0
#define SET_DUMP_PAGE(oid)  (dumpPage.volNo = oid.volNo, dumpPage.pageNo = oid.pageNo)


DeallocListElem dlHead;
extern Pool dlPool;


/*
 * Type Definition about transaction
 */
typedef struct {        /* 8 byte unsigned integer */
    UFour high;
    UFour low;
} XactID;

typedef enum { X_BROWSE_BROWSE, X_CS_BROWSE, X_CS_CS, X_RR_BROWSE, X_RR_CS, X_RR_RR } ConcurrencyLevel; /* isolation degree */


/*@
 * Function Prototypes
 */
/* Interface Function Prototypes */
Four LRDS_Init(void);
Four LRDS_AllocHandle(Four*);
Four LRDS_FormatDataVolume(Four, char**, char*, Four, Two, Four*, Four);
Four LRDS_Mount(Four, char**, Four*);
Four LRDS_BeginTransaction(XactID*, ConcurrencyLevel); /* COOKIE09NOV1999 */
Four LRDS_CommitTransaction(XactID*);
Four LRDS_AbortTransaction(XactID*);
Four LRDS_Dismount(Four);
Four LRDS_FreeHandle(Four);
Four LRDS_Final(void);

Four RDsM_AllocTrains(Four, Four, PageID *, Two, Four, Two, PageID *);

Four EduOM_Test(Four, Four);

Four eduom_Test_1_1(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_1_2(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_1_3(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_1_4(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_1_5(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_1_6(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_1_7(ObjectID*, ObjectID*, FILE *, bool *);

Four eduom_Test_2_1(ObjectID *, FILE *, bool *);
Four eduom_Test_2_2(ObjectID *, FILE *, bool *);

Four eduom_Test_3_1(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_3_2(ObjectID*, ObjectID*, FILE *, bool *);

Four eduom_Test_4_1(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_4_2(ObjectID*, ObjectID*, FILE *, bool *);
Four eduom_Test_4_3(ObjectID*, ObjectID*, FILE *, bool *);

Four eduom_CheckAllPages(PageID *, FILE *, bool *);
Four eduom_CheckOnePage(PageID *, FILE *, bool *);
void eduom_CheckPage(SlottedPage *, FILE *, bool *);

Four eduom_DumpPage(SlottedPage *);
Four eduom_GetNextPageID(PageID *);
char* itoa(Four val, Four base);

#endif /* _EDUOM_TESTMODULE_H_ */
